/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
/**
 * @file
 * @brief some functions to wrap some system functions
 *
 * @author Reinhard Pfau \<Reinhard.Pfau@gmx.de\>
 * @copyright &copy; Copyright 2009 by Intra2net AG
 */


#ifndef _ASYNCIO_SYSTEM_TOOLS_HPP_
#define _ASYNCIO_SYSTEM_TOOLS_HPP_

#include <string>


namespace AsyncIo
{
namespace Utils
{

bool unlink( const std::string& path );


class FileStat
{
    public:
        FileStat( const std::string& path);
        ~FileStat();

        void refresh();

        bool is_valid() const { return m_is_valid; }

        operator bool() const { return m_is_valid; }

        bool is_regular_file() const { return m_is_regular_file; }
        bool is_directory() const { return m_is_directory; }

    private:
        std::string m_path;

        bool m_is_valid;

        bool m_is_regular_file;
        bool m_is_directory;

}; // end of FileStat


} // end of namespace Utils
}// end of namespace AsyncIo


#endif
